/*		
		|||||||||||
	  ||	  	   ||
	||				 ||
	||				 ||
	||	 	Ring 	 ||
	||	   Attack	 ||
	||				 ||
	||				 ||
	  ||		   ||
		|||||||||||
		  Made by
		   Fyrid
*/

freeslot("TOL_RINGATTACK")
local gtrules = GTR_TIMELIMIT|GTR_FRIENDLY|GTR_ALLOWEXIT|GTR_LIVES|GTR_RESPAWNDELAY

G_AddGametype({
	name = "Ring Attack",
	identifier = "ringattack",
    typeoflevel = TOL_COMPETITION|TOL_RINGATTACK,
    rules = gtrules,
    rankingtype = GT_RACE,
	intermissiontype = int_race,
	defaulttimelimit = 3,
    headerleftcolor = 73,
    headerrightcolor = 98,
    description = "Get to the end before your rings drain completely! When your rings hit 0, its game over."
})

G_AddGametype({
	name = "Hardcore Ring Attack",
	identifier = "hardringattack",
    typeoflevel = TOL_COMPETITION|TOL_RINGATTACK,
    rules = gtrules|GTR_SPAWNENEMIES,
    rankingtype = GT_RACE,
	intermissiontype = int_race,
	defaulttimelimit = 3,
    headerleftcolor = 73,
    headerrightcolor = 35,
    description = "Ring Attack but a bit harder!"
})

addHook("PlayerSpawn", function(p)
	if gametype == GT_RINGATTACK
		p.rings = 25
	end
	
	if gametype == GT_HARDRINGATTACK
		p.rings = 20
	end
end)

addHook("ThinkFrame", function()
	if gametype == GT_RINGATTACK
		for p in players.iterate
			if (leveltime % 30 == 0)
				P_GivePlayerRings(p, -1)
			end
			
			if p.rings == 0
				P_DamageMobj(p.mo, nil, nil, 100)
			end
		end
	end
	
	if gametype == GT_HARDRINGATTACK
		for p in players.iterate
			if (leveltime % 20 == 0)
				P_GivePlayerRings(p, -1)
			end
			
			if p.rings == 0
				P_DamageMobj(p.mo, nil, nil, 100)
			end
		end
	end
end)

addHook("MobjDamage", function(target, inflictor, source)
	if gametype == GT_HARDRINGATTACK
		for p in players.iterate
			if (inflictor and inflictor.valid and inflictor.type == MT_PLAYER)
			and (target and target.valid and target.flags & MF_ENEMY)
				P_GivePlayerRings(p, 2)
			end
		end
	end
end)

